	device ZXSPECTRUM48
	
	org #6000
	
begin:

	jp start
	
SONGS_ALL=11

ITEM_Y=64
ITEM_HGT=7
ITEM_STEP=11
ITEM_X=11
ITEM_WDT=21
NOISE_WDT=11

music1:		incbin "adventure_time.bin.apl"
music2:		incbin "traffic_lights.bin.apl"
music3:		incbin "perfect_shitstorm.bin.apl"
music4:		incbin "alphabeard.bin.apl"
music5:		incbin "ear_shaver.bin.apl"
music6:		incbin "spinning_bits.bin.apl"
music7:		incbin "facemelter.bin.apl"
music8:		incbin "burning_bright.bin.apl"
music9:		incbin "balls_of_steel.bin.apl"
music10:	incbin "kinda_loud.bin.apl"
music11:	incbin "noise_in_my_head.bin.apl"

	display "music data ends ",/h,$

musicList:

	dw music1
	dw music2
	dw music3
	dw music4
	dw music5
	dw music6
	dw music7
	dw music8
	dw music9
	dw music10
	dw music11
	
start:

	di
	ld sp,0
	ld hl,playlist_apl
	ld de,screen_data
	call DecompressApLib
	ei

	;show screen in b/w
	
	ld hl,screen_seq
	ld b,192/8+8
	
show:

	push bc
	ld b,8
	
	halt

show1:
	
	push bc
	push hl
	
	ld c,(hl)
	ld b,0
	ld hl,screen_table
	add hl,bc
	add hl,bc

	ld c,(hl)
	inc hl
	ld b,(hl)
	ld hl,#4000
	add hl,bc
	ex de,hl
	ld hl,screen_data
	add hl,bc
	
	ld bc,32
	ldir
	
	ld b,32
.l0:
	ld a,(de)
	inc de
	and 16
	or 7
	out (#fe),a
	djnz .l0
	
	pop hl
	inc hl
	pop bc
	djnz show1
	
	pop bc
	djnz show


	ld sp,music_data

	;call shiftLeft
	
menuLoop:

	call drawCursor
	
	xor a
	in a,(#fe)
	cpl
	and #1f
	jr z,menuLoop

	ld bc,#fefe	;Czxcv
	in a,(c)
	and #01
	jr nz,.noCaps
	ld bc,#effe	;67890
	in a,(c)
	ld b,a
	and #01
	jp z,playSong
	ld a,b
	and #08
	jp z,curUp
	ld a,b
	and #10
	jp z,curDown
	jr .noPress
.noCaps
	ld bc,#effe	;67890
	in a,(c)
	ld b,a
	and #01
	jp z,playSong
	ld a,b
	and #02
	jp z,curUp
	ld a,b
	and #04
	jp z,curDown

	ld bc,#f7fe	;12345
	in a,(c)
	ld b,a
	and #04
	jp z,curDown
	ld a,b
	and #08
	jp z,curUp
	ld a,b
	and #10
	jp z,playSong

	ld bc,#fbfe	;qwerty
	in a,(c)
	and #01
	jp z,curUp
	ld bc,#fdfe	;asdfg
	in a,(c)
	and #01
	jp z,curDown
	ld bc,#7ffe	;bnmS_
	in a,(c)
	cpl
	and #1f
	jp nz,playSong
	ld bc,#bffe	;hjklE
	in a,(c)
	and #01
	jp z,playSong
.noPress
	jp menuLoop



curSound
	di
	ld bc,300
	ld hl,100
.l1
	srl h
	rl l
	add hl,bc
	ld a,l
	xor h
	and #10
	or #07
	out (#fe),a
	dec bc
	ld a,b
	or c
	jr nz,.l1
	ei
	ret
	
cur		db 0



down_hl:
	inc h		;DOWN_HL by Spencer Winsent
    ld a,h
    and #07
    ret nz
    ld a,l
    sub #e0
    ld l,a
    sbc a,a
    and #f8
    add a,h
    ld h,a
	ret
	
	
	
curUp:

	ld hl,cur
	ld a,(hl)
	or a
	jp z,menuLoop
	push hl
	call clearCursor
	call shiftRight
	pop hl
	dec (hl)
	call shiftLeft
	call curSound
	call waitRelease
	jp menuLoop
	
	
	
curDown:

	ld hl,cur
	ld a,(hl)
	cp SONGS_ALL-1
	jp nc,menuLoop
	push hl
	call clearCursor
	call shiftRight
	pop hl
	inc (hl)
	call shiftLeft
	call curSound
	call waitRelease
	jp menuLoop
	
	
	
curDownAuto:

	ld hl,cur
	ld a,(hl)
	cp SONGS_ALL-1
	ret nc
	push hl
	call clearCursor
	call shiftRight
	pop hl
	inc (hl)
	call shiftLeft
	scf
	ret
	
	

waitRelease:

	xor a
	in a,(#fe)
	cpl
	and #1f
	ret z

	call drawCursor
	
	jr waitRelease
	
	
	
playSong:

	call waitRelease
	
	call clearCursor
	
	ld hl,musicList
	ld a,(cur)
	add a,a
	add a,l
	ld l,a
	jr nc,$+3
	inc h

	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a

	di
	
	ld de,music_data
	call DecompressApLib
	
	ld hl,music_data
	call play
	
	ei
	
	push af
	ld a,7
	out (#fe),a
	pop af
	
	jp c,.next
	call waitRelease
	jp menuLoop
	
.next:
	ld b,1*60
	halt
	djnz $-1
	call curDownAuto
	jp nc,menuLoop
	jp playSong
	
	
	
drawCursor:

	call itemAdr

.noise_ptr=$+1
	ld de,0
	ld b,ITEM_HGT
	halt
.l0:
	push bc
	push hl
	ld ix,cursor_mask
	ld b,NOISE_WDT-1
.l1:
	ld a,(de)
	and (ix)
	ld (hl),a

	inc hl
	inc de
	inc ix
	djnz .l1
	
	ld a,(de)
	and (ix)
	and #fc
	ld (hl),a
	
	pop hl
	call down_hl
	pop bc
	djnz .l0
	
	ld hl,111
	add hl,de
	ld a,h
	and #1f
	ld h,a
	ld (.noise_ptr),hl
		
	ld hl,cursor_mask
	ld b,11
.l2:
	ld a,(hl)
	rlca
	ld (hl),a
	inc hl
	djnz .l2
	
	ret
	
	
	
clearCursor:

	call itemAdr

noise_ptr=$+1
	ld de,0
	ld b,ITEM_HGT
	halt
.l0:
	push bc
	push hl
	ld ix,cursor_mask
	ld bc,NOISE_WDT*256
.l1:
	ld (hl),c
	inc hl
	djnz .l1

	pop hl
	call down_hl
	pop bc
	djnz .l0
	
	ret
	


itemAdrList

	dup SONGS_ALL
	
SCR_ADR=#4000+(ITEM_Y&7)*256+((ITEM_Y/8)&7)*32+ITEM_Y/64*2048

	dw SCR_ADR

ITEM_Y=ITEM_Y+ITEM_STEP

	edup
	
	
itemAdr:

	ld a,(cur)
	ld hl,itemAdrList
	add a,a
	add a,l
	ld l,a
	jr nc,$+3
	inc h
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ret

shiftLeft:

	ld b,2
	halt
.ll
	push bc
	call itemAdr
	ld bc,ITEM_X
	add hl,bc
	ld bc,ITEM_WDT-1
	add hl,bc
	ld c,7
.l0
	ld a,l
	and a
	ld b,ITEM_WDT
	scf
.l1
	rl (hl)
	dec l
	djnz .l1
	ld l,a
	call down_hl
	dec c
	jr nz,.l0
	pop bc
	djnz .ll
	ret

shiftRight:

	ld b,2
	halt
.ll
	push bc
	call itemAdr
	ld bc,ITEM_X
	add hl,bc
	ld c,7
.l0
	ld a,l
	and a
	ld b,ITEM_WDT
	scf
.l1
	rr (hl)
	inc l
	djnz .l1
	ld l,a
	call down_hl
	dec c
	jr nz,.l0
	pop bc
	djnz .ll
	ret



cursor_mask:

	db %10001000
	db %10001000
	db %10010010
	db %01001001
	db %00100100
	db %10101010
	db %10101010
	db %11011001
	db %10110011
	db %00110110
	db %11101110
	
	
	include "unaplib_small.asm"
	
	display "engine start ",/h,$

	include "engine.asm"

	display "disposable data starts at ",/h,$
	
playlist_apl:

	incbin "playlist.scr.apl"
	
screen_table:

LINE=0
	dup 192
	dw LINE/64*2048+(LINE&7)*256+((LINE/8)&7)*32
LINE=LINE+1
	edup
	
screen_seq:

LINE=0
	dup 192/8+8
	
LOFF=0
	dup 8
	
LLINE=(LINE-LOFF)*8-LOFF
	if LLINE<0
LLINE=0
	endif
	if LLINE>=192
LLINE=0
	endif
	db 191-LLINE
LOFF=LOFF+1
	edup
	
LINE=LINE+1

	edup
	
	
	
end:

	display "code ends ",/h,$

	org #d680
	
music_data:

	org #e000

screen_data:

	savebin "earshaver.bin",begin,end-begin
	savesna "earshaver.sna",begin