	device ZXSPECTRUM48
	
	org #8000
	
begin:

	ei

	;hide screen contents, set all white
	
	ld hl,#5800
	ld de,#5801
	ld bc,768-1
	halt
	ld a,(7<<3)|7
	ld (hl),a
	ld a,7
	out (#fe),a
	ldir
	
	;fill pixels
	
	ld hl,#4000
	ld de,#4001
	ld bc,6144-1
	halt
	ld (hl),255
	ldir
	
	;set pixels visible
	
	ld hl,#5800
	ld de,#5801
	ld bc,768-1
	halt
	ld a,7
	ld (hl),a
	ldir
	
	;show screen in b/w
	
	ld hl,screen_seq
	ld b,192/8+8
	
show:

	push bc
	ld b,8
	
	halt

	
show1:

	push bc
	push hl
	
	ld c,(hl)
	ld b,0
	ld hl,screen_table
	add hl,bc
	add hl,bc

	ld c,(hl)
	inc hl
	ld b,(hl)
	ld hl,#4000
	add hl,bc
	ex de,hl
	ld hl,screen_data
	add hl,bc
		
	ld bc,32
	push de
	ldir
	pop de
	
	ld b,32
.l0:
	ld a,(de)
	inc de
	and 16
	or 7
	out (#fe),a
	djnz .l0
	
	pop hl
	inc hl
	pop bc
	djnz show1
	
	pop bc
	
	djnz show
	
	;show actual attributes
	
	ld bc,4*256
	
attrs:

	push bc
	
	ld hl,#5800
	ld de,#5801
	ld bc,768-1
	halt
	ld a,7
	ld (hl),a
	ldir
	
	pop bc
	
	call sfx
	
	push bc
	ld hl,screen_data+6144
	ld de,#5800
	ld bc,768
	halt
	ldir
	
	pop bc
	
	call sfx

	djnz attrs
	
	ret
	
	
	
sfx:
	
	ld a,c
	dec a
	and 7
	ld c,a
	
	push bc
	
	ld h,c
	ld l,c
	ld b,100
	ld a,7
.l0:
	xor 16
	out (#fe),a
	ld c,(hl)
	inc hl
	dec c
	jr nz,$-1
	
	djnz .l0
	
	pop bc
	
	ret
	
	
	include "unaplib_small.asm"
	
screen_table:

LINE=0
	dup 192
	dw LINE/64*2048+(LINE&7)*256+((LINE/8)&7)*32
LINE=LINE+1
	edup
	
screen_seq:

LINE=0
	dup 192/8+8
	
LOFF=0
	dup 8
	
LLINE=(LINE-LOFF)*8-LOFF
	if LLINE<0
LLINE=0
	endif
	if LLINE>=192
LLINE=0
	endif
	db LLINE
LOFF=LOFF+1
	edup
	
LINE=LINE+1

	edup
	
screen_data:

	incbin "screen.scr"
	
end:

	display "screen code ends ",/h,$

	savebin "earshasc.bin",begin,end-begin
	savesna "earshasc.sna",begin